// Code generated by bebopc-go; DO NOT EDIT.

package generated

import (
	"bytes"
	"io"

	"github.com/200sc/bebop"
	"github.com/200sc/bebop/iohelp"
)

type FurnitureFamily uint32

const (
	FurnitureFamily_Bed FurnitureFamily = 0
	FurnitureFamily_Table FurnitureFamily = 1
	FurnitureFamily_Shoe FurnitureFamily = 2
)

var _ bebop.Record = &Furniture{}

type Furniture struct {
	name string
	price uint32
	family FurnitureFamily
}

func (bbp Furniture) EncodeBebop(iow io.Writer) (err error) {
	w := iohelp.NewErrorWriter(iow)
	iohelp.WriteUint32(w, uint32(len(bbp.name)))
	w.Write([]byte(bbp.name))
	iohelp.WriteUint32(w, bbp.price)
	iohelp.WriteUint32(w, uint32(bbp.family))
	return w.Err
}

func (bbp *Furniture) DecodeBebop(ior io.Reader) (err error) {
	r := iohelp.NewErrorReader(ior)
	bbp.name = iohelp.ReadString(r)
	bbp.price = iohelp.ReadUint32(r)
	bbp.family = FurnitureFamily(iohelp.ReadUint32(r))
	return r.Err
}

func (bbp *Furniture) bodyLen() uint32 {
	bodyLen := uint32(0)
	bodyLen += 4
	bodyLen += uint32(len(bbp.name))
	bodyLen += 4
	bodyLen += 4
	return bodyLen
}

func makeFurniture(r iohelp.ErrorReader) (Furniture, error) {
	v := Furniture{}
	err := v.DecodeBebop(r)
	return v, err
}

func (bbp Furniture) GetName() string {
	return bbp.name
}

func (bbp Furniture) GetPrice() uint32 {
	return bbp.price
}

func (bbp Furniture) GetFamily() FurnitureFamily {
	return bbp.family
}

const RequestResponseOpCode = 0x31323334

var _ bebop.Record = &RequestResponse{}

type RequestResponse struct {
	availableFurniture []Furniture
}

func (bbp RequestResponse) EncodeBebop(iow io.Writer) (err error) {
	w := iohelp.NewErrorWriter(iow)
	iohelp.WriteUint32(w, uint32(RequestResponseOpCode))
	iohelp.WriteUint32(w, uint32(len(bbp.availableFurniture)))
	for _, elem := range bbp.availableFurniture {
		err = (elem).EncodeBebop(w)
		if err != nil {
			return err
		}
	}
	return w.Err
}

func (bbp *RequestResponse) DecodeBebop(ior io.Reader) (err error) {
	r := iohelp.NewErrorReader(ior)
	r.Read(make([]byte, 4))
	bbp.availableFurniture = make([]Furniture, iohelp.ReadUint32(r))
	for i1 := range bbp.availableFurniture {
		((bbp.availableFurniture[i1])), err = makeFurniture(r)
		if err != nil {
			return err
		}
	}
	return r.Err
}

func (bbp *RequestResponse) bodyLen() uint32 {
	bodyLen := uint32(0)
	bodyLen += 4
	for _, elem := range bbp.availableFurniture {
		bodyLen += (elem).bodyLen()
	}
	return bodyLen
}

func makeRequestResponse(r iohelp.ErrorReader) (RequestResponse, error) {
	v := RequestResponse{}
	err := v.DecodeBebop(r)
	return v, err
}

func (bbp RequestResponse) GetAvailableFurniture() []Furniture {
	return bbp.availableFurniture
}

const RequestCatalogOpCode = 0x494b4541

var _ bebop.Record = &RequestCatalog{}

type RequestCatalog struct {
	Family *FurnitureFamily
	// Deprecated: Nobody react to what I'm about to say...
	SecretTunnel *string
}

func (bbp RequestCatalog) EncodeBebop(iow io.Writer) (err error) {
	w := iohelp.NewErrorWriter(iow)
	iohelp.WriteUint32(w, bbp.bodyLen())
	if bbp.Family != nil {
		w.Write([]byte{1})
		iohelp.WriteUint32(w, uint32(*bbp.Family))
	}
	if bbp.SecretTunnel != nil {
		w.Write([]byte{2})
		iohelp.WriteUint32(w, uint32(len(*bbp.SecretTunnel)))
		w.Write([]byte(*bbp.SecretTunnel))
	}
	w.Write([]byte{0})
	return w.Err
}

func (bbp *RequestCatalog) DecodeBebop(ior io.Reader) (err error) {
	er := iohelp.NewErrorReader(ior)
	bodyLen := iohelp.ReadUint32(er)
	body := make([]byte, bodyLen)
	er.Read(body)
	r := iohelp.NewErrorReader(bytes.NewReader(body))
	for {
		switch iohelp.ReadByte(r) {
		case 1:
			bbp.Family = new(FurnitureFamily)
			*bbp.Family = FurnitureFamily(iohelp.ReadUint32(r))
		case 2:
			bbp.SecretTunnel = new(string)
			*bbp.SecretTunnel = iohelp.ReadString(r)
		default:
			return er.Err
		}
	}
}

func (bbp *RequestCatalog) bodyLen() uint32 {
	bodyLen := uint32(1)
	if bbp.Family != nil {
		bodyLen += 1
		bodyLen += 4
	}
	if bbp.SecretTunnel != nil {
		bodyLen += 1
		bodyLen += 4
		bodyLen += uint32(len(*bbp.SecretTunnel))
	}
	return bodyLen
}

func makeRequestCatalog(r iohelp.ErrorReader) (RequestCatalog, error) {
	v := RequestCatalog{}
	err := v.DecodeBebop(r)
	return v, err
}

